#!/bin/sh
set -e

# Gerekli Ortam Değişkenleri Oluşturuldu.
RESOLUTION=${RESOLUTION:-"1920x1080"}
USERNAME=${USERNAME:-"pardus"}
PASSWORD=${PASSWORD:-"pardus"}
SOUND=${SOUND:-true}
SUDO=${SUDO:-true}

# Belirlenen Kullanıcı Hesabı Oluşturuldu.
if id -u "$USERNAME" >/dev/null 2>&1; then
  echo "Kullanıcı Zaten var"
  else
  useradd -ms /bin/bash $USERNAME
  echo "$USERNAME:$PASSWORD" | chpasswd
  if [ "$SUDO" = true ]; then
    usermod -a -G sudo,adm,audio,video,plugdev $USERNAME
  fi
fi
# Ses Aktarımı için Pulse Audio Konfigurasyonu Yapıldı.
sed -i "s/USERNAME/$USERNAME/" /etc/xdg/autostart/sound.desktop

PARAM_SOUND=""
if [ "$SOUND" = true ]; then
  PARAM_SOUND="--audio-fifo-dir=/tmp/audio_fifo"
  mkdir /tmp/audio_fifo
  chown $USERNAME:$USERNAME /tmp/audio_fifo
  FIFO=/tmp/audio_fifo/audio.fifo
  echo "load-module module-pipe-sink sink_name=fifo file=$FIFO format=s16 rate=48000 channels=2" >> /oyunparki/default.pa
else
  rm -rf /etc/xdg/autostart/sound.desktop
fi

# X-Spice Şifre Ayarları Yapıldı.
PARAM_PASSWORD="--disable-ticketing --password $PASSWORD"
unset PASSWORD

# Run Klasörleri Oluşturuldu.
mkdir -p /run/user/1000
chown -R $USERNAME:$USERNAME /run/user/1000
export DESKTOP_SESSION=xfce
export XDG_SESSION_TYPE=x11
export XDG_DATA_DIRS=/usr/share/xfce4:/usr/local/share:/usr/share
export XDG_SESSION_DESKTOP=xfce
export XDG_CURRENT_DESKTOP=XFCE
export XDG_CONFIG_DIRS=/etc/xdg/pardus:/etc/xdg
export XDG_RUNTIME_DIR=/run/user/1000

Xspice --port 5900 $PARAM_SOUND --auto --vdagent $PARAM_PASSWORD $DISPLAY > /dev/null 2>&1 &
sleep 1
su $USERNAME -c "DISPLAY=$DISPLAY dbus-launch --exit-with-session xfce4-session" > /dev/null 2>&1